Loading...
Searching...
No Matches
pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar > Class Template Reference
Module registration

GeneralizedIterativeClosestPoint is an ICP variant that implements the generalized iterative closest point algorithm as described by Alex Segal et al. More...

`#include <pcl/registration/gicp.h>`

Inheritance diagram for pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >:

## Classes

struct | OptimizationFunctorWithIndices
| optimization functor structure More...

## Public Types

using | PointCloudSource = pcl::PointCloud<PointSource>
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud<PointTarget>
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
using | MatricesVector
using | MatricesVectorPtr = shared_ptr<MatricesVector>
using | MatricesVectorConstPtr = shared_ptr<const MatricesVector>
using | InputKdTree = typename Registration<PointSource, PointTarget, Scalar>::KdTree
using | InputKdTreePtr
using | Ptr
using | ConstPtr
using | Vector3 = typename Eigen::Matrix<Scalar, 3, 1>
using | Vector4 = typename Eigen::Matrix<Scalar, 4, 1>
using | Vector6d = Eigen::Matrix<double, 6, 1>
using | Matrix3 = typename Eigen::Matrix<Scalar, 3, 3>
using | Matrix4
using | Matrix6d = Eigen::Matrix<double, 6, 6>
using | AngleAxis = typename Eigen::AngleAxis<Scalar>
Public Types inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, float >
using | PointCloudSource
using | PointCloudSourcePtr
using | PointCloudSourceConstPtr
using | PointCloudTarget
using | PointCloudTargetPtr
using | PointCloudTargetConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr
using | Ptr
using | ConstPtr
using | Matrix4
Public Types inherited from pcl::Registration< PointSource, PointTarget, float >
using | Matrix4
using | Ptr
using | ConstPtr
using | CorrespondenceRejectorPtr
using | KdTree
using | KdTreePtr
using | KdTreeReciprocal
using | KdTreeReciprocalPtr
using | PointCloudSource
using | PointCloudSourcePtr
using | PointCloudSourceConstPtr
using | PointCloudTarget
using | PointCloudTargetPtr
using | PointCloudTargetConstPtr
using | PointRepresentationConstPtr
using | TransformationEstimation
using | TransformationEstimationPtr
using | TransformationEstimationConstPtr
using | CorrespondenceEstimation
using | CorrespondenceEstimationPtr
using | CorrespondenceEstimationConstPtr
using | UpdateVisualizerCallbackSignature
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud.
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

PCL_MAKE_ALIGNED_OPERATOR_NEW | GeneralizedIterativeClosestPoint ()
| Empty constructor.
void | setInputSource (const PointCloudSourceConstPtr &cloud) override
| Provide a pointer to the input dataset.
void | setSourceCovariances (const MatricesVectorPtr &covariances)
| Provide a pointer to the covariances of the input source (if computed externally!).
void | setInputTarget (const PointCloudTargetConstPtr &target) override
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to).
void | setTargetCovariances (const MatricesVectorPtr &covariances)
| Provide a pointer to the covariances of the input target (if computed externally!).
void | estimateRigidTransformationBFGS (const PointCloudSource &cloud_src, const pcl::Indices &indices_src, const PointCloudTarget &cloud_tgt, const pcl::Indices &indices_tgt, Matrix4 &transformation_matrix)
| Estimate a rigid rotation transformation between a source and a target point cloud using an iterative non-linear BFGS approach.
void | estimateRigidTransformationNewton (const PointCloudSource &cloud_src, const pcl::Indices &indices_src, const PointCloudTarget &cloud_tgt, const pcl::Indices &indices_tgt, Matrix4 &transformation_matrix)
| Estimate a rigid rotation transformation between a source and a target point cloud using an iterative non-linear Newton approach.
const Eigen::Matrix3d & | mahalanobis (std::size_t index) const
void | computeRDerivative (const Vector6d &x, const Eigen::Matrix3d &dCost_dR_T, Vector6d &g) const
| Computes the derivative of the cost function w.r.t rotation angles.
void | setRotationEpsilon (double epsilon)
| Set the rotation epsilon (maximum allowable difference between two consecutive rotations) in order for an optimization to be considered as having converged to the final solution.
double | getRotationEpsilon () const
| Get the rotation epsilon (maximum allowable difference between two consecutive rotations) as set by the user.
void | setCorrespondenceRandomness (int k)
| Set the number of neighbors used when selecting a point neighbourhood to compute covariances.
int | getCorrespondenceRandomness () const
| Get the number of neighbors used when computing covariances as set by the user.
void | useBFGS ()
| Use BFGS optimizer instead of default Newton optimizer.
void | setMaximumOptimizerIterations (int max)
| Set maximum number of iterations at the optimization step.
int | getMaximumOptimizerIterations () const
| Return maximum number of iterations at the optimization step.
void | setTranslationGradientTolerance (double tolerance)
| Set the minimal translation gradient threshold for early optimization stop.
double | getTranslationGradientTolerance () const
| Return the minimal translation gradient threshold for early optimization stop.
void | setRotationGradientTolerance (double tolerance)
| Set the minimal rotation gradient threshold for early optimization stop.
double | getRotationGradientTolerance () const
| Return the minimal rotation gradient threshold for early optimization stop.
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use.
Public Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, float >
| IterativeClosestPoint ()
| Empty constructor.
IterativeClosestPoint & | operator= (const IterativeClosestPoint &)=delete
| ~IterativeClosestPoint () override=default
| Empty destructor.
pcl::registration::DefaultConvergenceCriteria< float >::Ptr | getConvergeCriteria ()
| Returns a pointer to the DefaultConvergenceCriteria used by the IterativeClosestPoint class.
void | setInputSource (const PointCloudSourceConstPtr &cloud) override
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target).
void | setInputTarget (const PointCloudTargetConstPtr &cloud) override
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to).
void | setUseReciprocalCorrespondences (bool use_reciprocal_correspondence)
| Set whether to use reciprocal correspondence or not.
bool | getUseReciprocalCorrespondences () const
| Obtain whether reciprocal correspondence are used or not.
void | setNumberOfThreads (unsigned int nr_threads)
| Set the number of threads to use.
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, float >
| Registration ()
| Empty constructor.
| ~Registration () override=default
| destructor.
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object.
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object.
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target.
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target.
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud.
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud.
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding).
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud.
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method.
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method.
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for.
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user.
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for.
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user.
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop.
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user.
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target.
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target.
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user.
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation).
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user.
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points.
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration.
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target).
bool | hasConverged () const
| Return the state of convergence after the last align run.
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
const std::string & | getClassName () const
| Abstract class get name method.
bool | initCompute ()
| Internal computation initialization.
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed.
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list.
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors.
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list.
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors.
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

template<typename PointT>
void | computeCovariances (typename pcl::PointCloud< PointT >::ConstPtr cloud, const typename pcl::search::KdTree< PointT >::Ptr tree, MatricesVector &cloud_covariances)
| compute points covariances matrices according to the K nearest neighbors.
double | matricesInnerProd (const Eigen::MatrixXd &mat1, const Eigen::MatrixXd &mat2) const
void | computeTransformation (PointCloudSource &output, const Matrix4 &guess) override
| Rigid transformation computation method with initial guess.
bool | searchForNeighbors (const PointSource &query, pcl::Indices &index, std::vector< float > &distance)
| Search for the closest nearest neighbor of a given point.
void | applyState (Matrix4 &t, const Vector6d &x) const
| compute transformation matrix from transformation matrix
Protected Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, float >
virtual void | transformCloud (const PointCloudSource &input, PointCloudSource &output, const Matrix4 &transform)
| Apply a rigid transform to a given dataset.
void | computeTransformation (PointCloudSource &output, const Matrix4 &guess) override
| Rigid transformation computation method with initial guess.
virtual void | determineRequiredBlobData ()
| Looks at the Estimators and Rejectors and determines whether their blob-setter methods need to be called.
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, float >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point.
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess.
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

int | k_correspondences_ {20}
| The number of neighbors used for covariances computation.
double | gicp_epsilon_ {0.001}
| The epsilon constant for gicp paper; this is NOT the convergence tolerance default: 0.001.
double | rotation_epsilon_ {2e-3}
| The epsilon constant for rotation error.
Matrix4 | base_transformation_
| base transformation
const PointCloudSource * | tmp_src_
| Temporary pointer to the source dataset.
const PointCloudTarget * | tmp_tgt_
| Temporary pointer to the target dataset.
const pcl::Indices * | tmp_idx_src_
| Temporary pointer to the source dataset indices.
const pcl::Indices * | tmp_idx_tgt_
| Temporary pointer to the target dataset indices.
MatricesVectorPtr | input_covariances_
| Input cloud points covariances.
MatricesVectorPtr | target_covariances_
| Target cloud points covariances.
std::vector< Eigen::Matrix3d > | mahalanobis_
| Mahalanobis matrices holder.
int | max_inner_iterations_ {20}
| maximum number of optimizations
double | translation_gradient_tolerance_ {1e-2}
| minimal translation gradient for early optimization stop
double | rotation_gradient_tolerance_ {1e-2}
| minimal rotation gradient for early optimization stop
std::function< void(const pcl::PointCloud< PointSource > &cloud_src, const pcl::Indices &src_indices, const pcl::PointCloud< PointTarget > &cloud_tgt, const pcl::Indices &tgt_indices, Matrix4 &transformation_matrix)> | rigid_transformation_estimation_
Protected Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, float >
std::size_t | x_idx_offset_
| XYZ fields offset.
std::size_t | y_idx_offset_
std::size_t | z_idx_offset_
std::size_t | nx_idx_offset_
| Normal fields offset.
std::size_t | ny_idx_offset_
std::size_t | nz_idx_offset_
bool | use_reciprocal_correspondence_
| The correspondence type used for correspondence estimation.
bool | source_has_normals_
| Internal check whether source dataset has normals or not.
bool | target_has_normals_
| Internal check whether target dataset has normals or not.
bool | need_source_blob_
| Checks for whether estimators and rejectors need various data.
bool | need_target_blob_
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, float >
std::string | reg_name_
| The registration method name.
KdTreePtr | tree_
| A pointer to the spatial search object.
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source.
int | nr_iterations_
| The number of iterations the internal optimization ran for (used internally).
int | max_iterations_
| The maximum number of iterations the internal optimization should run for.
int | ransac_iterations_
| The number of iterations RANSAC should run for.
PointCloudTargetConstPtr | target_
| The input point cloud dataset target.
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations.
Matrix4 | transformation_
| The transformation matrix estimated by the registration method.
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally).
double | transformation_epsilon_
| The maximum difference between two consecutive transformations in order to consider convergence (user defined).
double | transformation_rotation_epsilon_
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined).
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target.
double | inlier_threshold_
| The inlier distance threshold for the internal RANSAC outlier rejection loop.
bool | converged_
| Holds internal convergence state, given user parameters.
unsigned int | min_number_correspondences_
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation.
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step.
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation.
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud.
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use.
bool | target_cloud_updated_
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again.
bool | source_cloud_updated_
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again.
bool | force_no_recompute_
| A flag which, if set, means the tree operating on the target cloud will never be recomputed.
bool | force_no_recompute_reciprocal_
| A flag which, if set, means the tree operating on the source cloud will never be recomputed.
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud.
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, float >
pcl::registration::DefaultConvergenceCriteria< float >::Ptr | convergence_criteria_

## Detailed Description

template<typename PointSource, typename PointTarget, typename Scalar = float>
class pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >

GeneralizedIterativeClosestPoint is an ICP variant that implements the generalized iterative closest point algorithm as described by Alex Segal et al.

in http://www.robots.ox.ac.uk/~avsegal/resources/papers/Generalized_ICP.pdf The approach is based on using anisotropic cost functions to optimize the alignment after closest point assignments have been made. The original code uses GSL and ANN while in ours we use FLANN and Newton's method for optimization (call useBFGS to switch to BFGS optimizer, however Newton is usually faster and more accurate). Basic usage example:

pcl::GeneralizedIterativeClosestPoint<pcl::PointXYZ, pcl::PointXYZ> reg;
reg.setInputSource(src);
reg.setInputTarget(tgt);
// use default parameters or set them yourself, for example:
// reg.setMaximumIterations(...);
// reg.setTransformationEpsilon(...);
// reg.setRotationEpsilon(...);
// reg.setCorrespondenceRandomness(...);
pcl::PointCloud<pcl::PointXYZ>::Ptr output(new pcl::PointCloud<pcl::PointXYZ>);
// supply a better guess, if possible:
Eigen::Matrix4f guess = Eigen::Matrix4f::Identity();
reg.align(*output, guess);
std::cout << reg.getFinalTransformation() << std::endl;
pcl::GeneralizedIterativeClosestPoint
GeneralizedIterativeClosestPoint is an ICP variant that implements the generalized iterative closest ...
Definition gicp.h:76
pcl::GeneralizedIterativeClosestPoint::setInputSource
void setInputSource(const PointCloudSourceConstPtr &cloud) override
Provide a pointer to the input dataset.
Definition gicp.h:159
pcl::GeneralizedIterativeClosestPoint::setInputTarget
void setInputTarget(const PointCloudTargetConstPtr &target) override
Provide a pointer to the input target (e.g., the point cloud that we want to align the input source t...
Definition gicp.h:193
pcl::PointCloud
PointCloud represents the base class in PCL for storing collections of 3D points.
Definition point_cloud.h:174
pcl::PointCloud::Ptr
shared_ptr< PointCloud< PointT > > Ptr
Definition point_cloud.h:414
pcl::Registration::getFinalTransformation
Matrix4 getFinalTransformation()
Get the final transformation matrix estimated by the registration method.
Definition registration.h:259
pcl::Registration::align
void align(PointCloudSource &output)
Call the registration algorithm which estimates the transformation and returns the transformed source...
Definition registration.hpp:168

Author
  Nizar Sallem

Definition at line 75 of file gicp.h.

## Member Typedef Documentation

## AngleAxis

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::AngleAxis = typename Eigen::AngleAxis<Scalar>

Definition at line 132 of file gicp.h.

## ConstPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::ConstPtr

Initial value:
shared_ptr<
const GeneralizedIterativeClosestPoint<PointSource, PointTarget, Scalar>>
pcl::GeneralizedIterativeClosestPoint::GeneralizedIterativeClosestPoint
PCL_MAKE_ALIGNED_OPERATOR_NEW GeneralizedIterativeClosestPoint()
Empty constructor.
Definition gicp.h:137

Definition at line 122 of file gicp.h.

## InputKdTree

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::InputKdTree = typename Registration<PointSource, PointTarget, Scalar>::KdTree

Definition at line 116 of file gicp.h.

## InputKdTreePtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::InputKdTreePtr

Initial value:
typename Registration<PointSource, PointTarget, Scalar>::KdTreePtr
pcl::Registration::KdTreePtr
typename KdTree::Ptr KdTreePtr
Definition registration.h:71

Definition at line 117 of file gicp.h.

## MatricesVector

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::MatricesVector

Initial value:
std::vector<Eigen::Matrix3d, Eigen::aligned_allocator<Eigen::Matrix3d>>

Definition at line 111 of file gicp.h.

## MatricesVectorConstPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::MatricesVectorConstPtr = shared_ptr<const MatricesVector>

Definition at line 114 of file gicp.h.

## MatricesVectorPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::MatricesVectorPtr = shared_ptr<MatricesVector>

Definition at line 113 of file gicp.h.

## Matrix3

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix3 = typename Eigen::Matrix<Scalar, 3, 3>

Definition at line 128 of file gicp.h.

## Matrix4

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix4

Initial value:
typename IterativeClosestPoint<PointSource, PointTarget, Scalar>::Matrix4
pcl::IterativeClosestPoint::Matrix4
typename Registration< PointSource, PointTarget, Scalar >::Matrix4 Matrix4
Definition icp.h:143

Definition at line 129 of file gicp.h.

## Matrix6d

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix6d = Eigen::Matrix<double, 6, 6>

Definition at line 131 of file gicp.h.

## PointCloudSource

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSource = pcl::PointCloud<PointSource>

Definition at line 100 of file gicp.h.

## PointCloudSourceConstPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr

Definition at line 102 of file gicp.h.

## PointCloudSourcePtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSourcePtr = typename PointCloudSource::Ptr

Definition at line 101 of file gicp.h.

## PointCloudTarget

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTarget = pcl::PointCloud<PointTarget>

Definition at line 104 of file gicp.h.

## PointCloudTargetConstPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr

Definition at line 106 of file gicp.h.

## PointCloudTargetPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTargetPtr = typename PointCloudTarget::Ptr

Definition at line 105 of file gicp.h.

## PointIndicesConstPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointIndicesConstPtr = PointIndices::ConstPtr

Definition at line 109 of file gicp.h.

## PointIndicesPtr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointIndicesPtr = PointIndices::Ptr

Definition at line 108 of file gicp.h.

## Ptr

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Ptr

Initial value:
shared_ptr<GeneralizedIterativeClosestPoint<PointSource, PointTarget, Scalar>>

Definition at line 120 of file gicp.h.

## Vector3

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Vector3 = typename Eigen::Matrix<Scalar, 3, 1>

Definition at line 125 of file gicp.h.

## Vector4

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Vector4 = typename Eigen::Matrix<Scalar, 4, 1>

Definition at line 126 of file gicp.h.

## Vector6d

template<typename PointSource, typename PointTarget, typename Scalar = float>

using pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::Vector6d = Eigen::Matrix<double, 6, 1>

Definition at line 127 of file gicp.h.

## Constructor & Destructor Documentation

## GeneralizedIterativeClosestPoint()

template<typename PointSource, typename PointTarget, typename Scalar = float>

PCL_MAKE_ALIGNED_OPERATOR_NEW pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::GeneralizedIterativeClosestPoint | ( |  | ) |

inline

Empty constructor.

Definition at line 137 of file gicp.h.

References pcl::Registration< PointSource, PointTarget, float >::corr_dist_threshold_, estimateRigidTransformationNewton(), mahalanobis_, pcl::Registration< PointSource, PointTarget, float >::max_iterations_, pcl::Registration< PointSource, PointTarget, float >::min_number_correspondences_, pcl::Registration< PointSource, PointTarget, float >::reg_name_, rigid_transformation_estimation_, setNumberOfThreads(), and pcl::Registration< PointSource, PointTarget, float >::transformation_epsilon_.

Referenced by pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::OptimizationFunctorWithIndices::OptimizationFunctorWithIndices().

## Member Function Documentation

## applyState()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::applyState | ( | Matrix4 & | t,
|  | const Vector6d & | x ) const

protected

compute transformation matrix from transformation matrix

Definition at line 918 of file gicp.hpp.

Referenced by estimateRigidTransformationBFGS().

## computeCovariances()

template<typename PointSource, typename PointTarget, typename Scalar>
template<typename PointT>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::computeCovariances | ( | typename pcl::PointCloud< PointT >::ConstPtr | cloud,
|  | const typename pcl::search::KdTree< PointT >::Ptr | tree,
|  | MatricesVector & | cloud_covariances )

protected

compute points covariances matrices according to the K nearest neighbors.

K is set via setCorrespondenceRandomness() method.

Parameters

  [in] | cloud | pointer to point cloud
  [in] | tree | KD tree performer for nearest neighbors search
  [out] | cloud_covariances | covariances matrices for each point in the cloud

Definition at line 73 of file gicp.hpp.

References gicp_epsilon_, k_correspondences_, pcl::search::KdTree< PointT, Tree >::nearestKSearch(), and pcl::PointCloud< PointT >::size().

Referenced by computeTransformation().

## computeRDerivative()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::computeRDerivative | ( | const Vector6d & | x,
|  | const Eigen::Matrix3d & | dCost_dR_T,
|  | Vector6d & | g ) const

Computes the derivative of the cost function w.r.t rotation angles.

rotation matrix is obtainded from rotation angles x[3], x[4] and x[5]

Returns
  d/d_Phi, d/d_Theta, d/d_Psi respectively in g[3], g[4] and g[5]

Parameters

  [in] | x | array representing 3D transformation
  [in] | dCost_dR_T | the transpose of the derivative of the cost function w.r.t rotation matrix
  [out] | g | gradient vector

Definition at line 205 of file gicp.hpp.

## computeTransformation()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::computeTransformation | ( | PointCloudSource & | output,
|  | const Matrix4 & | guess )

inline override protected

Rigid transformation computation method with initial guess.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | the initial guess of the transformation to compute

Definition at line 769 of file gicp.hpp.

References base_transformation_, computeCovariances(), pcl::Registration< PointSource, PointTarget, float >::converged_, pcl::Registration< PointSource, PointTarget, float >::corr_dist_threshold_, pcl::registration::CorrespondenceEstimation< PointSource, PointTarget, Scalar >::determineCorrespondences(), pcl::Registration< PointSource, PointTarget, float >::final_transformation_, pcl::Registration< PointSource, PointTarget, float >::getClassName(), pcl::Registration< PointSource, PointTarget, float >::getSearchMethodTarget(), pcl::PCLBase< PointSource >::indices_, pcl::Registration< PointSource, PointTarget, float >::initComputeReciprocal(), pcl::PCLBase< PointSource >::input_, input_covariances_, pcl::invert3x3SymMatrix(), mahalanobis_, pcl::make_shared(), pcl::Registration< PointSource, PointTarget, float >::max_iterations_, pcl::Registration< PointSource, PointTarget, float >::nr_iterations_, pcl::Registration< PointSource, PointTarget, float >::previous_transformation_, rigid_transformation_estimation_, rotation_epsilon_, pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >::setInputSource(), pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >::setInputTarget(), pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >::setNumberOfThreads(), pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >::setSearchMethodTarget(), pcl::PointCloud< PointT >::size(), pcl::Registration< PointSource, PointTarget, float >::target_, target_covariances_, pcl::Registration< PointSource, PointTarget, float >::transformation_, pcl::Registration< PointSource, PointTarget, float >::transformation_epsilon_, pcl::transformPointCloud(), pcl::Registration< PointSource, PointTarget, float >::tree_, pcl::Registration< PointSource, PointTarget, float >::tree_reciprocal_, and pcl::Registration< PointSource, PointTarget, float >::update_visualizer_.

## estimateRigidTransformationBFGS()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::estimateRigidTransformationBFGS | ( | const PointCloudSource & | cloud_src,
|  | const pcl::Indices & | indices_src,
|  | const PointCloudTarget & | cloud_tgt,
|  | const pcl::Indices & | indices_tgt,
|  | Matrix4 & | transformation_matrix )

Estimate a rigid rotation transformation between a source and a target point cloud using an iterative non-linear BFGS approach.

Parameters

  [in] | cloud_src | the source point cloud dataset
  [in] | indices_src | the vector of indices describing the points of interest in cloud_src
  [in] | cloud_tgt | the target point cloud dataset
  [in] | indices_tgt | the vector of indices describing the correspondences of the interest points from indices_src
  [in,out] | transformation_matrix | the resultant transformation matrix

Definition at line 296 of file gicp.hpp.

References applyState(), pcl::Registration< PointSource, PointTarget, float >::getClassName(), max_inner_iterations_, pcl::Registration< PointSource, PointTarget, float >::min_number_correspondences_, BFGS< FunctorType >::minimizeInit(), BFGS< FunctorType >::minimizeOneStep(), BFGSSpace::NoProgress, BFGS< FunctorType >::Parameters::order, BFGS< FunctorType >::parameters, BFGS< FunctorType >::Parameters::rho, BFGSSpace::Running, BFGS< FunctorType >::Parameters::sigma, BFGSSpace::Success, BFGS< FunctorType >::Parameters::tau1, BFGS< FunctorType >::Parameters::tau2, BFGS< FunctorType >::Parameters::tau3, BFGS< FunctorType >::testGradient(), tmp_idx_src_, tmp_idx_tgt_, tmp_src_, and tmp_tgt_.

Referenced by useBFGS().

## estimateRigidTransformationNewton()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::estimateRigidTransformationNewton | ( | const PointCloudSource & | cloud_src,
|  | const pcl::Indices & | indices_src,
|  | const PointCloudTarget & | cloud_tgt,
|  | const pcl::Indices & | indices_tgt,
|  | Matrix4 & | transformation_matrix )

Estimate a rigid rotation transformation between a source and a target point cloud using an iterative non-linear Newton approach.

Parameters

  [in] | cloud_src | the source point cloud dataset
  [in] | indices_src | the vector of indices describing the points of interest in cloud_src
  [in] | cloud_tgt | the target point cloud dataset
  [in] | indices_tgt | the vector of indices describing the correspondences of the interest points from indices_src
  [in,out] | transformation_matrix | the resultant transformation matrix

Definition at line 372 of file gicp.hpp.

Referenced by GeneralizedIterativeClosestPoint().

## getCorrespondenceRandomness()

template<typename PointSource, typename PointTarget, typename Scalar = float>

int pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::getCorrespondenceRandomness | ( |  | ) | const

inline

Get the number of neighbors used when computing covariances as set by the user.

Definition at line 303 of file gicp.h.

References k_correspondences_.

## getMaximumOptimizerIterations()

template<typename PointSource, typename PointTarget, typename Scalar = float>

int pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::getMaximumOptimizerIterations | ( |  | ) | const

inline

Return maximum number of iterations at the optimization step.

Definition at line 335 of file gicp.h.

References max_inner_iterations_.

## getRotationEpsilon()

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::getRotationEpsilon | ( |  | ) | const

inline

Get the rotation epsilon (maximum allowable difference between two consecutive rotations) as set by the user.

Definition at line 282 of file gicp.h.

References rotation_epsilon_.

## getRotationGradientTolerance()

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::getRotationGradientTolerance | ( |  | ) | const

inline

Return the minimal rotation gradient threshold for early optimization stop.

Definition at line 370 of file gicp.h.

References rotation_gradient_tolerance_.

## getTranslationGradientTolerance()

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::getTranslationGradientTolerance | ( |  | ) | const

inline

Return the minimal translation gradient threshold for early optimization stop.

Definition at line 353 of file gicp.h.

References translation_gradient_tolerance_.

## mahalanobis()

template<typename PointSource, typename PointTarget, typename Scalar = float>

const Eigen::Matrix3d & pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::mahalanobis | ( | std::size_t | index | ) | const

inline

Returns
  Mahalanobis distance matrix for the given point index

Definition at line 248 of file gicp.h.

References mahalanobis_.

## matricesInnerProd()

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::matricesInnerProd | ( | const Eigen::MatrixXd & | mat1,
|  | const Eigen::MatrixXd & | mat2 ) const

inline protected

Returns
  trace of mat1 . mat2

Parameters

  mat1 | matrix of dimension nxm
  mat2 | matrix of dimension mxp

Definition at line 450 of file gicp.h.

## searchForNeighbors()

template<typename PointSource, typename PointTarget, typename Scalar = float>

bool pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::searchForNeighbors | ( | const PointSource & | query,
|  | pcl::Indices & | index,
|  | std::vector< float > & | distance )

inline protected

Search for the closest nearest neighbor of a given point.

Parameters

  query | the point to search a nearest neighbour for
  index | vector of size 1 to store the index of the nearest neighbour found
  distance | vector of size 1 to store the distance to nearest neighbour found

Definition at line 476 of file gicp.h.

References pcl::Registration< PointSource, PointTarget, float >::tree_.

## setCorrespondenceRandomness()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setCorrespondenceRandomness | ( | int | k | ) |

inline

Set the number of neighbors used when selecting a point neighbourhood to compute covariances.

A higher value will bring more accurate covariance matrix but will make covariances computation slower.

Parameters

  k | the number of neighbors to use when computing covariances

Definition at line 294 of file gicp.h.

References k_correspondences_.

## setInputSource()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputSource | ( | const PointCloudSourceConstPtr & | cloud | ) |

inline override virtual

Provide a pointer to the input dataset.

Parameters

  cloud | the const boost shared pointer to a PointCloud message

Reimplemented from pcl::Registration< PointSource, PointTarget, float >.

Definition at line 159 of file gicp.h.

References pcl::Registration< PointSource, PointTarget, float >::getClassName(), input_covariances_, pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputSource(), and pcl::PointCloud< PointT >::size().

## setInputTarget()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputTarget | ( | const PointCloudTargetConstPtr & | target | ) |

inline override

Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to).

Parameters

  [in] | target | the input point cloud target

Definition at line 193 of file gicp.h.

References pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputTarget(), and target_covariances_.

## setMaximumOptimizerIterations()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setMaximumOptimizerIterations | ( | int | max | ) |

inline

Set maximum number of iterations at the optimization step.

Parameters

  [in] | max | maximum number of iterations for the optimizer

Definition at line 327 of file gicp.h.

References max_inner_iterations_.

## setNumberOfThreads()

template<typename PointSource, typename PointTarget, typename Scalar>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setNumberOfThreads | ( | unsigned int | nr_threads = 0 | ) |

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 50 of file gicp.hpp.

Referenced by GeneralizedIterativeClosestPoint().

## setRotationEpsilon()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setRotationEpsilon | ( | double | epsilon | ) |

inline

Set the rotation epsilon (maximum allowable difference between two consecutive rotations) in order for an optimization to be considered as having converged to the final solution.

Parameters

  epsilon | the rotation epsilon

Definition at line 273 of file gicp.h.

References rotation_epsilon_.

## setRotationGradientTolerance()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setRotationGradientTolerance | ( | double | tolerance | ) |

inline

Set the minimal rotation gradient threshold for early optimization stop.

Parameters

  [in] | tolerance | rotation gradient threshold in radians

Definition at line 362 of file gicp.h.

References rotation_gradient_tolerance_.

## setSourceCovariances()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setSourceCovariances | ( | const MatricesVectorPtr & | covariances | ) |

inline

Provide a pointer to the covariances of the input source (if computed externally!).

If not set, GeneralizedIterativeClosestPoint will compute the covariances itself. Make sure to set the covariances AFTER setting the input source point cloud (setting the input source point cloud will reset the covariances).

Parameters

  [in] | covariances | the input source covariances

Definition at line 184 of file gicp.h.

References input_covariances_.

## setTargetCovariances()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setTargetCovariances | ( | const MatricesVectorPtr & | covariances | ) |

inline

Provide a pointer to the covariances of the input target (if computed externally!).

If not set, GeneralizedIterativeClosestPoint will compute the covariances itself. Make sure to set the covariances AFTER setting the input source point cloud (setting the input source point cloud will reset the covariances).

Parameters

  [in] | covariances | the input target covariances

Definition at line 207 of file gicp.h.

References target_covariances_.

## setTranslationGradientTolerance()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::setTranslationGradientTolerance | ( | double | tolerance | ) |

inline

Set the minimal translation gradient threshold for early optimization stop.

Parameters

  [in] | tolerance | translation gradient threshold in meters

Definition at line 344 of file gicp.h.

References translation_gradient_tolerance_.

## useBFGS()

template<typename PointSource, typename PointTarget, typename Scalar = float>

void pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::useBFGS | ( |  | ) |

inline

Use BFGS optimizer instead of default Newton optimizer.

Definition at line 311 of file gicp.h.

References estimateRigidTransformationBFGS(), and rigid_transformation_estimation_.

## Member Data Documentation

## base_transformation_

template<typename PointSource, typename PointTarget, typename Scalar = float>

Matrix4 pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::base_transformation_

protected

base transformation

Definition at line 401 of file gicp.h.

Referenced by computeTransformation().

## gicp_epsilon_

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::gicp_epsilon_ {0.001}

protected

The epsilon constant for gicp paper; this is NOT the convergence tolerance default: 0.001.

Definition at line 392 of file gicp.h.

Referenced by computeCovariances().

## input_covariances_

template<typename PointSource, typename PointTarget, typename Scalar = float>

MatricesVectorPtr pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::input_covariances_

protected

Input cloud points covariances.

Definition at line 416 of file gicp.h.

Referenced by computeTransformation(), setInputSource(), and setSourceCovariances().

## k_correspondences_

template<typename PointSource, typename PointTarget, typename Scalar = float>

int pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::k_correspondences_ {20}

protected

The number of neighbors used for covariances computation.

default: 20

Definition at line 386 of file gicp.h.

Referenced by computeCovariances(), getCorrespondenceRandomness(), and setCorrespondenceRandomness().

## mahalanobis_

template<typename PointSource, typename PointTarget, typename Scalar = float>

std::vector<Eigen::Matrix3d> pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::mahalanobis_

protected

Mahalanobis matrices holder.

Definition at line 422 of file gicp.h.

Referenced by computeTransformation(), GeneralizedIterativeClosestPoint(), and mahalanobis().

## max_inner_iterations_

template<typename PointSource, typename PointTarget, typename Scalar = float>

int pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::max_inner_iterations_ {20}

protected

maximum number of optimizations

Definition at line 425 of file gicp.h.

Referenced by estimateRigidTransformationBFGS(), getMaximumOptimizerIterations(), and setMaximumOptimizerIterations().

## rigid_transformation_estimation_

template<typename PointSource, typename PointTarget, typename Scalar = float>

std::function<void(const pcl::PointCloud<PointSource>& cloud_src, const pcl::Indices& src_indices, const pcl::PointCloud<PointTarget>& cloud_tgt, const pcl::Indices& tgt_indices, Matrix4& transformation_matrix)> pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::rigid_transformation_estimation_

protected

Definition at line 514 of file gicp.h.

Referenced by computeTransformation(), GeneralizedIterativeClosestPoint(), and useBFGS().

## rotation_epsilon_

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::rotation_epsilon_ {2e-3}

protected

The epsilon constant for rotation error.

(In GICP the transformation epsilon is split in rotation part and translation part). default: 2e-3

Definition at line 398 of file gicp.h.

Referenced by computeTransformation(), getRotationEpsilon(), and setRotationEpsilon().

## rotation_gradient_tolerance_

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::rotation_gradient_tolerance_ {1e-2}

protected

minimal rotation gradient for early optimization stop

Definition at line 431 of file gicp.h.

Referenced by getRotationGradientTolerance(), and setRotationGradientTolerance().

## target_covariances_

template<typename PointSource, typename PointTarget, typename Scalar = float>

MatricesVectorPtr pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::target_covariances_

protected

Target cloud points covariances.

Definition at line 419 of file gicp.h.

Referenced by computeTransformation(), setInputTarget(), and setTargetCovariances().

## tmp_idx_src_

template<typename PointSource, typename PointTarget, typename Scalar = float>

const pcl::Indices* pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::tmp_idx_src_

protected

Temporary pointer to the source dataset indices.

Definition at line 410 of file gicp.h.

Referenced by estimateRigidTransformationBFGS().

## tmp_idx_tgt_

template<typename PointSource, typename PointTarget, typename Scalar = float>

const pcl::Indices* pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::tmp_idx_tgt_

protected

Temporary pointer to the target dataset indices.

Definition at line 413 of file gicp.h.

Referenced by estimateRigidTransformationBFGS().

## tmp_src_

template<typename PointSource, typename PointTarget, typename Scalar = float>

const PointCloudSource* pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::tmp_src_

protected

Temporary pointer to the source dataset.

Definition at line 404 of file gicp.h.

Referenced by estimateRigidTransformationBFGS().

## tmp_tgt_

template<typename PointSource, typename PointTarget, typename Scalar = float>

const PointCloudTarget* pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::tmp_tgt_

protected

Temporary pointer to the target dataset.

Definition at line 407 of file gicp.h.

Referenced by estimateRigidTransformationBFGS().

## translation_gradient_tolerance_

template<typename PointSource, typename PointTarget, typename Scalar = float>

double pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget, Scalar >::translation_gradient_tolerance_ {1e-2}

protected

minimal translation gradient for early optimization stop

Definition at line 428 of file gicp.h.

Referenced by getTranslationGradientTolerance(), and setTranslationGradientTolerance().

The documentation for this class was generated from the following files:

- pcl/registration/gicp.h
- pcl/registration/impl/gicp.hpp